arch_binaries  := $(arch_binaries) libffi

p_ffi	= libffi$(FFI_SONAME)
p_ffid	= libffi$(FFI_SONAME)-dev
p_64ffi	= lib64ffi$(FFI_SONAME)
p_64ffid= lib64ffi$(FFI_SONAME)-dev

d_ffi	= debian/$(p_ffi)
d_ffid	= debian/$(p_ffid)
d_64ffi	= debian/$(p_64ffi)
d_64ffid= debian/$(p_64ffid)

dirs_ffi = \
	$(docdir)/$(p_ffi) \
	$(PF)/$(libdir)
files_ffi = \
	$(PF)/$(libdir)/libffi.so.*

dirs_ffid = \
	$(docdir) \
	$(PF)/include \
	$(gcc_lib_dir)/include
files_ffid = \
	$(gcc_lib_dir)/include/libffi \
	$(PF)/include/{ffi.h,ffitarget.h} \
	$(PF)/$(libdir)/libffi.{a,so,la}

ifeq ($(with_lib64ffi),yes)
	arch_binaries  := $(arch_binaries) lib64ffi
	dirs_64ffi   = $(PF)/$(lib64)
	files_64ffi  = $(PF)/$(lib64)/libffi.so.*
	dirs_64ffid  = $(PF)/$(lib64)
	files_64ffid = $(PF)/$(lib64)/libffi.{a,so,la}
endif

$(binary_stamp)-libffi: $(install_stamp)
	dh_testdir
	dh_testroot
	mv $(install_stamp) $(install_stamp)-tmp

	rm -rf $(d_ffi) $(d_ffid)
	dh_installdirs -p$(p_ffi) $(dirs_ffi)
	dh_installdirs -p$(p_ffid) $(dirs_ffid)

	mv $(d)/$(gcc_lib_dir)/include/libffi/ffitarget.h $(d)/$(PF)/include/.

	DH_COMPAT=2 dh_movefiles -p$(p_ffi) $(files_ffi)
	DH_COMPAT=2 dh_movefiles -p$(p_ffid) $(files_ffid)

	dh_installdocs -p$(p_ffi) $(srcdir)/libffi/README
	dh_installchangelogs -p$(p_ffi) $(srcdir)/libffi/ChangeLog
	cp -p $(srcdir)/libffi/LICENSE $(d_ffi)/$(docdir)/$(p_ffi)/copyright
	cp -p $(srcdir)/libffi/ChangeLog.libgcj \
		$(d_ffi)/$(docdir)/$(p_ffi)/changelog.libgcj
	debian/dh_doclink -p$(p_ffid) $(p_ffi)

	debian/dh_rmemptydirs -p$(p_ffi)
	debian/dh_rmemptydirs -p$(p_ffid)

	dh_strip -p$(p_ffi) -p$(p_ffid)
	dh_compress -p$(p_ffi) -p$(p_ffid)
	dh_fixperms -p$(p_ffi) -p$(p_ffid)
	dh_makeshlibs -p$(p_ffi) -V '$(p_ffi) (>= $(DEB_FFI_SOVERSION))'
	dh_shlibdeps -p$(p_ffi) -p$(p_ffid)
	dh_gencontrol -p$(p_ffi) -p$(p_ffid) \
		-- -v$(DEB_VERSION) $(common_substvars)
	dh_installdeb -p$(p_ffi) -p$(p_ffid)
	dh_md5sums -p$(p_ffi) -p$(p_ffid)
	dh_builddeb -p$(p_ffi) -p$(p_ffid)

	trap '' 1 2 3 15; touch $@; mv $(install_stamp)-tmp $(install_stamp)

$(binary_stamp)-lib64ffi: $(install_stamp)
	dh_testdir
	dh_testroot
	mv $(install_stamp) $(install_stamp)-tmp

	rm -rf $(d_64ffi) $(d_64ffid)
	dh_installdirs -p$(p_64ffi) $(dirs_64ffi)
	dh_installdirs -p$(p_64ffid) $(dirs_64ffid)

	DH_COMPAT=2 dh_movefiles -p$(p_64ffi) $(files_64ffi)
	DH_COMPAT=2 dh_movefiles -p$(p_64ffid) $(files_64ffid)

	dh_installdocs -p$(p_64ffi) $(srcdir)/libffi/README
	dh_installchangelogs -p$(p_64ffi) $(srcdir)/libffi/ChangeLog
	cp -p $(srcdir)/libffi/LICENSE $(d_64ffi)/$(docdir)/$(p_64ffi)/copyright
	cp -p $(srcdir)/libffi/ChangeLog.libgcj \
		$(d_64ffi)/$(docdir)/$(p_64ffi)/changelog.libgcj
	debian/dh_doclink -p$(p_64ffid) $(p_64ffi)

	debian/dh_rmemptydirs -p$(p_64ffi)
	debian/dh_rmemptydirs -p$(p_64ffid)

	dh_strip -p$(p_64ffi) -p$(p_64ffid)
	dh_compress -p$(p_64ffi) -p$(p_64ffid)
	dh_fixperms -p$(p_64ffi) -p$(p_64ffid)
	dh_makeshlibs -p$(p_64ffi) -V '$(p_64ffi) (>= $(DEB_FFI_SOVERSION))'
	dh_shlibdeps -p$(p_64ffi) -p$(p_64ffid)
	dh_gencontrol -p$(p_64ffi) -p$(p_64ffid) \
		-- -v$(DEB_VERSION) $(common_substvars)
	dh_installdeb -p$(p_64ffi) -p$(p_64ffid)
	dh_md5sums -p$(p_64ffi) -p$(p_64ffid)
	dh_builddeb -p$(p_64ffi) -p$(p_64ffid)

	trap '' 1 2 3 15; touch $@; mv $(install_stamp)-tmp $(install_stamp)
